SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'initialize 5/17/2012 22:19'!
initialize 
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'initialize 5/17/2012 23:16'!
mouseAction: aBlock

	^mouseAction := aBlock ! !

!LOCell methodsFor: 'event handling' stamp: 'initialize 5/17/2012 23:11'!
mouseUp: anEvent
	""
	mouseAction value! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'as yet unclassified' stamp: 'initialize 5/17/2012 23:16'!
cellsPerSide
	"El numero de celdas en cada lado del juego"

	^10! !

!LOGame methodsFor: 'initialization' stamp: 'initialize 5/17/2012 22:34'!
initialize 
	| sampleCell width height n |
	
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n)@(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'initialization' stamp: 'initialize 5/17/2012 23:15'!
newCellAt:  i at: j
	"Create a cell for position (i,j) and add it to my on-screen
	representation at the appropiate screen position. Answer the new cell"

	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width ) @ ((j - 1) * c height) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt: i at: j].
	^c! !

!LOGame methodsFor: 'as yet unclassified' stamp: 'initialize 5/17/2012 22:58'!
toggleNeighboursOfCellAt: i at: j
	""
	(i > 1) ifTrue:[(cells at: i -1 at: j ) toggleState].
	(i < self cellsPerSide ) ifTrue: [(cells at: i+1 at: j) toggleState].
	(j > 1) ifTrue: [(cells at: i at: j - 1) toggleState ].
	(j < self cellsPerSide) ifTrue: [(	cells at: i at: j +1 ) toggleState ].! !
